#!/usr/local/bin/perl
#############################################################################
# fichier : babel:~cmic/badgedirect.pl
# machine :  Linux babel 2.6.18.2-34-default 
#  Time-stamp: <2010-10-15 09:28:43 cmic>
# 
# -version 2 <2010-10-15 09:28:43 cmic> Nouvelle version de Kelio -> nouvelle 
# version de autobadge. Seuls quelques parametres ont chang. (server_secu et 
# server_badge). Pour recuperer les parametres, utiliser wsp.pl
# wsp.pl -a -v > log . Les requets sont dans le fichier log. 
# -version 1 badger sur sur chronos. Cett eversion fonctionne apres une 
# longue mise au point. Pour Kelio V8.1B9. Aprs la version 7, le protocole
# a t modifi. Le cookie doit tre pris en compte et les noms des
# repertoires auquels adresser les requetes ont t changs.
#                                                   Michel Marcon cmic@
#############################################################################
#
use strict;
use warnings;
use HTTP::Cookies;
use HTTP::Request::Common qw(POST GET);
use LWP::UserAgent;
#
my ($ua, $cookie_jar, $answer, $jeton);
my $server="http://cetu-intranet:8089/open/";
my $server_secu    =$server . "j_spring_security_check";
my $server_login   =$server . "login";
my $server_homepage=$server . "homepage";
my $server_badge   =$server . "webgtp/badge";
my $server_global  =$server . "global";
my ($login, $pass, $jsession);
my $request = new HTTP::Request;
my $cookies="/home/cmic/wsp/cookies.txt";
my $DEBUG=1;
#
unlink ($cookies);
$ua=new LWP::UserAgent();
$cookie_jar=HTTP::Cookies->new( file => "$cookies", 
				autosave => 1,
				ignore_discard => 1
				);
$ua->cookie_jar($cookie_jar);
$ua->agent("Microsoft Internet Explorer/6");
$ua->no_proxy("cetu.prv");
#$ua->proxy('http', 'http://babel:5364/');
$request = new HTTP::Request('GET' => "$server_login");
$answer=$ua->request($request);
$_=$cookie_jar->as_string; 
/JSESSIONID=([0-9A-Z]*);/;
$jsession=$1;
print "-cookie ", $jsession, "\n" if $DEBUG;
# 
print "Nom :";
$login=<STDIN>; chomp ($login); 
$login=uc $login;
print "Pass:";
$pass=<STDIN>; chomp $pass;
#$request->referer($server_login);
$cookie_jar->add_cookie_header($request);
print "-construction page " , $server_secu, "\n";
#
$request = POST "$server_secu" , [
        'ACTION' => "ACTION_VALIDER_LOGIN",
        'j_username' => "$login" ,
	'j_password' => "$pass", 
];
#
# Recup de la reponse
#
$answer=$ua->request($request) or die "Login impossible.";
#
$request = GET $server_homepage;
#$request->referer($server_login);
$cookie_jar->add_cookie_header($request);
$answer=$ua->request($request) or die "Homepage impossible.";
#
$_=$answer->content;
/id=\"JETON_INTRANET\" value=\"([0-9]*)\"/;
$jeton=$1;
print "-jeton trouved ", $jeton, "\n" if $DEBUG;
#
$request = POST "$server_badge" , [
        'ACTION' => "BADGER_ES",
        'ACTION_SWITCH' => "",
        'module' => "gtp.name",
        'choixApplication' => "",
        'application' => "1",
        'JETON_INTRANET' => $jeton ,
] ;
#
$answer=$ua->request($request) or die "Badgeage impossible.";
#
# quitter proprement 8-)
#
$request = POST "$server_global" , [
        'ACTION' => "QUITTER",
        'ACTION_SWITCH' => "",
        'module' => "gtp.name",
        'choixApplication' => "",
        'application' => "1",
] ;
$answer=$ua->request($request) or die "Quitter impossible.";
#
__END__;

